<template>
  <div class="testStyle" no-gutters>
    <!-- BARRA TOPO -->
    <section class="primary topBar">
      <div class="contentTopBar">
        <span class="headline text-uppercase test--text">UDESC</span>
        <v-divider class="mx-2" vertical color="white" />
        <span class="headline text-uppercase white--text font-weight-light">Polvo</span>
        <span
          class="headline white--text font-weight-light pl-2"
          style="font-size: 1.2rem !important"
          >- Resultado
        </span>
      </div>
      <v-spacer />
      <v-btn outlined color="white" class="mr-6" @click="handleClose">Fechar</v-btn>
    </section>
    <section class="contentStyleTest">
      <!-- MENU ESQUERDA -->
      <div class="leftStyle">
        <!-- MENU QUESTOES PROVA -->
        <span>
          <v-subheader
            ><v-icon class="pr-2" color="primary">mdi-chart-bar</v-icon>Resultado da
            avaliação</v-subheader
          >
          <v-subheader class="primary--text"
            ><b>{{ activeTest.title }}</b></v-subheader
          >
          <v-list dense class="pt-0">
            <v-list-item-group color="primary" v-model="activeQuestion" mandatory>
              <v-list-item v-for="(question, index) in activeTest.questions" :key="index">
                <v-list-item-action class="mr-5">
                  <v-icon color="primary" small>mdi-circle-medium</v-icon>
                </v-list-item-action>
                <v-list-item-content>
                  <v-list-item-title v-text="`Questão ${index + 1}`" />
                </v-list-item-content>
              </v-list-item>
            </v-list-item-group>
          </v-list>
        </span>
      </div>

      <!-- MENU DIREITA -->
      <div class="rightStyle">
        <!-- VISÃO PROVA -->
        <span v-if="activeTest.questions.length > 0">
          <v-row no-gutters justify="center" class="mb-4">
            <span class="primary--text" style="font-size:1.3rem">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-file-document</v-icon
              ><b>{{ activeTest.title }}</b>
            </span>
          </v-row>
          <!-- LAYOUT QUESTOES -->
          <v-row no-gutters justify="center">
            <v-card style="width: 80%" class="pa-8">
              <v-row class="mb-4">
                <b>
                  Questão {{ activeQuestion + 1 }} -
                  {{ activeTest.questions[activeQuestion].body }} ({{
                    activeTest.questions[activeQuestion].weight
                  }}
                  pontos)
                </b>
              </v-row>
              <!-- VERDADEIRO OU FALSO -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'trueOrFalse'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="max-width: 90px; display: flex; align-self: center">
                    <span class="pr-2">{{ orderQuestion[index] }}</span>
                    <v-select
                      disabled
                      v-model="answer.userAnswer"
                      class="ma-0 pa-0"
                      outlined
                      dense
                      flat
                      :items="trueFalse"
                      item-text="label"
                      item-value="value"
                    />
                  </v-col>
                  <v-col class="mt-2 ml-3" style="display:flex; align-self: start">
                    {{ answer.text }}
                  </v-col>
                </v-row>
              </span>
              <!-- DISSERTATIVA -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'dissertation'">
                <v-text-field
                  disabled
                  label="Sua resposta"
                  v-model="activeTest.questions[activeQuestion].userAnswer"
                ></v-text-field>
              </span>
              <!-- OBJETIVA/MULTIPLA ESCOLHA -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'objective'">
                <v-radio-group v-model="activeTest.questions[activeQuestion].userAnswer" disabled>
                  <v-radio
                    v-for="(n, index) in activeTest.questions[activeQuestion].answers"
                    :key="index"
                    :label="`${orderQuestion[index]} ${n.text}`"
                    :value="n.text"
                  >
                    <template v-slot:label>
                      <div class="grey--text text--darken-3">
                        {{ orderQuestion[index] }} {{ n.text }}
                      </div>
                    </template></v-radio
                  >
                </v-radio-group>
              </span>
              <!-- MULTIPLA ESCOLHA MULTI VALORES -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'multipleChoice'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col style="max-width: 60px; display: flex; align-self: center">
                    <span class="pr-2">{{ orderQuestion[index] }}</span>
                    <v-checkbox
                      disabled
                      v-model="answer.userAnswer"
                      item-value="value"
                      class="ma-0 pa-0"
                    />
                  </v-col>
                  <v-col class="ml-0" style="display:flex; align-self: start">
                    {{ answer.text }}
                  </v-col>
                </v-row>
              </span>
              <!-- SOMATORIO -->
              <span v-if="activeTest.questions[activeQuestion].questionType == 'summation'">
                <v-row
                  class="mb-1 grey--text text--darken-3"
                  v-for="(answer, index) in activeTest.questions[activeQuestion].answers"
                  :key="index"
                  no-gutters
                >
                  <v-col class="mt-2 ml-3" style="display:flex; align-self: start">
                    {{ Math.pow(2, index) }} - {{ answer.text }}
                  </v-col>
                </v-row>
                <v-row style="display: flex" class="mt-7">
                  <span class="pt-2 pr-4"><b>Resposta:</b></span>
                  <v-text-field
                    disabled
                    style="max-width:350px"
                    class="ma-0 pa-0"
                    label="Valor do somatório das respostas corretas"
                    v-model="activeTest.questions[activeQuestion].userAnswer"
                  ></v-text-field>
                </v-row>
              </span>
            </v-card>
          </v-row>
          <v-row no-gutters justify="center" class="mt-5">
            <v-card color="transparent" elevation="0" style="width: 80%" align="center">
              <v-btn
                :disabled="activeQuestion == 0"
                outlined
                class="mr-4"
                elevation="0"
                color="primary"
                @click="activeQuestion--"
                >Anterior</v-btn
              >
              <v-btn
                v-if="activeQuestion !== activeTest.questions.length - 1"
                outlined
                elevation="0"
                color="primary"
                @click="activeQuestion++"
                >Próxima</v-btn
              >
            </v-card>
          </v-row>
        </span>
      </div>
    </section>
  </div>
</template>

<script>
import Cam from '../camUser.vue'
export default {
  name: 'ShowResult',
  props: {
    test: { type: Object, default: () => {} },
    userRole: { type: String, default: '' },
  },
  components: { Cam },
  data: () => ({
    activeQuestion: 0,
    activeTest: {},
    orderQuestion: [
      'a)',
      'b)',
      'c)',
      'd)',
      'e)',
      'f)',
      'g)',
      'h)',
      'i)',
      'j)',
      'k)',
      'l)',
      'm)',
      'n)',
    ],
    trueFalse: [
      { label: 'V', value: true },
      { label: 'F', value: false },
    ],
    alert: {
      status: false,
      icon: 'mdi-alert',
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    finishTest: false,
    model: { text: 'Tomas de Aquino', userAnswer: '' },
  }),
  beforeMount() {
    /*
    A resposta do usuário é salva dentro da propria pergunta, no objeto activeTest
    para V-F e Multipla escolha multi-respostas

    activeTest.questions[indice da pergunta].answers
    answers: {text:"alternativa", userAnswer: ""}

    na dissertativa, multipla escolha e  somatório ->  é salva em:
    activeTest.questions[indice da pergunta].userAnswer
    */
    this.activeTest = JSON.parse(JSON.stringify(this.test))
    this.activeTest.questions.forEach((element) => {
      if (element.questionType !== 'dissertation') {
        element.answers = element.correctAnswers.concat(element.incorrectAnswers)
        element.answers.forEach((item) => {
          item = Object.assign(item, { userAnswer: '' })
        })
        element.userAnswer = ''
        this.shuffleArray(element.answers)
        // apenas para simular resposta escolhida
        if (element.questionType == 'objective') element.userAnswer = 'Tomas de Aquino'
        if (element.questionType == 'summation') element.userAnswer = '2'
        if (element.questionType == 'multipleChoice')
          element.answers.forEach((item) => {
            item.userAnswer = true
          })
        if (element.questionType == 'trueOrFalse')
          element.answers.forEach((item) => {
            item.userAnswer = true
          })
        //fim simulação
      } else {
        element.userAnswer = ''
        // apenas para simular resposta escolhida
        if (element.questionType == 'dissertation') element.userAnswer = 'Tomas de Aquino'
        //fim simulação
      }
    })
  },
  watch: {
    'test.id'() {
      if (this.test.questions.length > 0) {
        this.activeQuestion = 0
        this.activeTest = JSON.parse(JSON.stringify(this.test))
        this.activeTest.questions.forEach((element) => {
          if (element.questionType !== 'dissertation') {
            element.answers = element.correctAnswers.concat(element.incorrectAnswers)
            element.answers.forEach((item) => {
              item = Object.assign(item, { userAnswer: '' })
            })
            element.userAnswer = ''
            this.shuffleArray(element.answers)
            // apenas para simular resposta escolhida
            if (element.questionType == 'objective') element.userAnswer = 'Tomas de Aquino'
            if (element.questionType == 'summation') element.userAnswer = '2'
            if (element.questionType == 'multipleChoice')
              element.answers.forEach((item) => {
                item.userAnswer = true
              })
            if (element.questionType == 'trueOrFalse')
              element.answers.forEach((item) => {
                item.userAnswer = true
              })
            //fim simulação
          } else {
            element.userAnswer = ''
            // apenas para simular resposta escolhida
            if (element.questionType == 'dissertation') element.userAnswer = 'Tomas de Aquino'
            //fim simulação
          }
        })
      }
    },
  },
  methods: {
    handleClose() {
      this.$emit('handleClose')
    },

    // métodos para PROVA
    shuffleArray(array) {
      for (let i = array.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1))
        ;[array[i], array[j]] = [array[j], array[i]]
      }
    },
  },
}
</script>

<style>
.testStyle {
  background: white;
  height: 100vh;
  width: 100%;
  display: block;
  align-content: flex-start;
}

.topBar {
  display: flex;
  width: 100%;
  height: 64px;
  align-items: center;
  -webkit-box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
  -moz-box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
  box-shadow: 0px 3px 7px 0px rgba(50, 50, 50, 0.35);
}

.contentTopBar {
  display: flex;
  height: 1.6rem;
  align-items: center;
  margin-left: 68px;
}

.contentStyleTest {
  display: flex;
  min-height: calc(100% - 64px);
  /* min-height: 100%; */
  background: white;
}

.leftStyle {
  width: 256px;
  min-height: 100%;
  border-right: 1px solid rgba(50, 50, 50, 0.15);
  padding-top: 24px;
}

.rightStyle {
  width: calc(100% - 256px);
  padding-top: 24px;
}

@media all and (max-width: 800px) {
  .leftStyle {
    display: none;
    height: 100%;
  }
  .rightStyle {
    width: 100%;
    height: 100%;
    padding-top: 24px;
  }
}
</style>
